(*
     Browse For Folder component
     Delphi 2/3/4 only
     (c) 1998 Ray Adams
*)
unit folderBrowse;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, ShlObj;

type
  TBrowseFlag = (
    bf_BrowseForComputer,
    bf_BrowseForPrinter,
    bf_DontGoBelowDomain,
    bf_ReturnFSanceStors,
    bf_ReturnOnlyFSDIRS,
    bf_StatusText);
  TBrowseFlags = set of TBrowseFlag;

  TBrowseLocation= (
  bl_STANDART,
  bl_CUSTOM,
  bl_DESKTOP,
  bl_PROGRAMS,
  bl_CONTROLS,
  bl_PRINTERS,
  bl_PERSONAL,
  bl_FAVORITES,
  bl_STARTUP,
  bl_RECENT,
  bl_SENDTO,
  bl_BITBUCKET,
  bl_STARTMENU,
  bl_DESKTOPDIRECTORY,
  bl_DRIVES,
  bl_NETWORK,
  bl_NETHOOD,
  bl_FONTS,
  bl_TEMPLATES,
  bl_COMMON_STARTMENU,
  bl_COMMON_PROGRAMS,
  bl_COMMON_STARTUP,
  bl_COMMON_DESKTOPDIRECTORY,
  bl_APPDATA,
  bl_PRINTHOOD);

  TBrowseForFolder = class(TComponent)
  private
  FBrowseInfo:TBrowseInfo;
  FRoot:PItemIDList;
  FDisplayName:String;
  FTitle:String;
  FFolderName:String;
  FORoot:TBrowseLocation;
    { Private declarations }
    procedure ReadData( Reader :TReader );
    procedure WriteData( Writer :TWriter );
    procedure SetFlags( Value :TBrowseFlags );
    function GetFlags :TBrowseFlags;
    function GetOperFlag( F :Cardinal ) :Boolean;
    procedure SetOperFlag( F :Cardinal; V :Boolean );
  protected
    { Protected declarations }
    procedure DefineProperties( Filer :TFiler ); override;
  public
    { Public declarations }
    constructor Create( anOwner :TComponent ); override;
    destructor Destroy; override;
    function Execute :Boolean;
    procedure SetRoot(Root:PItemIdList);
    procedure SetFunction(tF:TFNBFFCallBack);
    procedure SetLParam(Param:LParam);
  published
    { Published declarations }
  property DisplayName:String read FDisplayName;
  property Title:String read FTitle write FTitle;
  property FolderName:String read FFolderName;
  property Flags :TBrowseFlags
      read GetFlags  write SetFlags stored false;
  property Root:TBrowseLocation read FoRoot write FoRoot;
  end;

procedure Register;

implementation

constructor TBrowseForFolder.Create( anOwner :TComponent );
begin
 inherited Create( anOwner );
  FFolderName:='';
 FTitle:='Select';
end;

destructor TBrowseForFolder.Destroy;
begin
 inherited Destroy;
end;

function TBrowseForFolder.Execute;
var iGetRoot,Res:PItemIDList;
    sTemp:String;

begin
FBrowseInfo.hwndOwner:=0;
FBrowseInfo.lpszTitle:=PChar(FTitle);
case foRoot of
  bl_CUSTOM:iGetRoot:=FRoot;
  bl_DESKTOP:shGetSpecialFolderLocation(0,CSIDL_DESKTOP ,iGetRoot);
  bl_PROGRAMS:shGetSpecialFolderLocation(0,CSIDL_PROGRAMS ,iGetRoot);
  bl_CONTROLS:shGetSpecialFolderLocation(0,CSIDL_CONTROLS ,iGetRoot);
  bl_PRINTERS:shGetSpecialFolderLocation(0,CSIDL_PRINTERS ,iGetRoot);
  bl_PERSONAL:shGetSpecialFolderLocation(0,CSIDL_PERSONAL ,iGetRoot);
  bl_FAVORITES:shGetSpecialFolderLocation(0,CSIDL_FAVORITES ,iGetRoot);
  bl_STARTUP:shGetSpecialFolderLocation(0,CSIDL_STARTUP ,iGetRoot);
  bl_RECENT:shGetSpecialFolderLocation(0,CSIDL_RECENT ,iGetRoot);
  bl_SENDTO:shGetSpecialFolderLocation(0,CSIDL_SENDTO ,iGetRoot);
  bl_BITBUCKET:shGetSpecialFolderLocation(0,CSIDL_BITBUCKET ,iGetRoot);
  bl_STARTMENU:shGetSpecialFolderLocation(0,CSIDL_STARTMENU ,iGetRoot);
  bl_DESKTOPDIRECTORY:shGetSpecialFolderLocation(0,CSIDL_DESKTOPDIRECTORY ,iGetRoot);
  bl_DRIVES:shGetSpecialFolderLocation(0,CSIDL_DRIVES ,iGetRoot);
  bl_NETWORK:shGetSpecialFolderLocation(0,CSIDL_NETWORK ,iGetRoot);
  bl_NETHOOD:shGetSpecialFolderLocation(0,CSIDL_NETHOOD ,iGetRoot);
  bl_FONTS:shGetSpecialFolderLocation(0,CSIDL_FONTS ,iGetRoot);
  bl_TEMPLATES:shGetSpecialFolderLocation(0,CSIDL_TEMPLATES ,iGetRoot);
  bl_COMMON_STARTMENU:shGetSpecialFolderLocation(0,CSIDL_COMMON_STARTMENU ,iGetRoot);
  bl_COMMON_PROGRAMS:shGetSpecialFolderLocation(0,CSIDL_COMMON_PROGRAMS ,iGetRoot);
  bl_COMMON_STARTUP:shGetSpecialFolderLocation(0,CSIDL_COMMON_STARTUP ,iGetRoot);
  bl_COMMON_DESKTOPDIRECTORY:shGetSpecialFolderLocation(0,CSIDL_COMMON_DESKTOPDIRECTORY ,iGetRoot);
  bl_APPDATA:shGetSpecialFolderLocation(0,CSIDL_APPDATA ,iGetRoot);
  bl_PRINTHOOD:shGetSpecialFolderLocation(0,CSIDL_PRINTHOOD ,iGetRoot);
end;
if  foRoot<>bl_STANDART then
FBrowseInfo.pidlRoot:=iGetRoot;
FBrowseInfo.hwndOwner:=(owner as TForm).handle;
GetMem(FBrowseInfo.pszDisplayName,255);
res:=ShBrowseForFolder(FBrowseInfo);
if res=nil then result:=false
else begin
     result:=true;
     SetLength(sTemp,255);
     SHGetPathFromIDList(Res,pchar(sTemp));
     FFolderName:=sTemp;
     FDisplayName:=FBrowseInfo.pszDisplayName;
     end;
FreeMem(FBrowseInfo.pszDisplayName,255);
end;

procedure TBrowseForFolder.SetRoot;
begin
FRoot:=Root;
end;

procedure TBrowseForFolder.SetFunction;
begin
FBrowseInfo.lpfn:=tf;
end;

procedure TBrowseForFolder.SetLParam;
begin
FBrowseInfo.lParam:=Param;
end;


procedure Register;
begin
  RegisterComponents('Ray Adams', [TBrowseForFolder]);
end;

procedure TBrowseForFolder.DefineProperties( Filer :TFiler );
begin
 Inherited DefineProperties( Filer );
 Filer.DefineProperty( 'data', ReadData, WriteData, true );
end;

procedure TBrowseForFolder.ReadData( Reader :TReader );
begin
  Reader.Read( FBrowseInfo, SizeOf( TBrowseInfo ) );
end;

procedure TBrowseForFolder.WriteData( Writer :TWriter );
begin
  writer.write( FBrowseInfo, SizeOf( TBrowseInfo ) );
end;

procedure TBrowseForFolder.SetFlags( Value :TBrowseFlags );
begin
SetOperFlag(BIF_BROWSEFORCOMPUTER,bf_BROWSEFORCOMPUTER in Value);
SetOperFlag(BIF_BROWSEFORPRINTER,bf_BROWSEFORPRINTER in Value);
SetOperFlag(BIF_DONTGOBELOWDOMAIN,bf_DONTGOBELOWDOMAIN in Value);
SetOperFlag(BIF_RETURNFSANCESTORS,bf_RETURNFSANCESTORS in Value);
SetOperFlag(BIF_RETURNONLYFSDIRS,bf_RETURNONLYFSDIRS in Value);
SetOperFlag(BIF_STATUSTEXT,bf_STATUSTEXT in Value);
end;

function TBrowseForFolder.GetFlags;
begin
  result := [];
  if GetOperFlag(BIF_BROWSEFORCOMPUTER) then include( result,bf_BROWSEFORCOMPUTER);
  if GetOperFlag(BIF_BROWSEFORPRINTER) then include( result,bf_BROWSEFORPRINTER);
  if GetOperFlag(BIF_DONTGOBELOWDOMAIN) then include( result,bf_DONTGOBELOWDOMAIN);
  if GetOperFlag(BIF_RETURNFSANCESTORS) then include( result,bf_RETURNFSANCESTORS);
  if GetOperFlag(BIF_RETURNONLYFSDIRS) then include( result,bf_RETURNONLYFSDIRS);
  if GetOperFlag(BIF_STATUSTEXT) then include( result,bf_STATUSTEXT);
end;

function TBrowseForFolder.GetOperFlag( F :Cardinal ):boolean;
begin
  result := ( FBrowseInfo.ulFlags and F ) <> 0;
end;

procedure TBrowseForFolder.SetOperFlag( F :Cardinal; V :Boolean );
begin
 with FBrowseInfo do
  if V then ulFlags := ulFlags or F else ulFlags := ulFlags and ( not F );
end;


end.
